<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_PERSONAL_MATERIAL_REQ';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/inventory/includes/ui/personal_material_requisitions_ui.inc");
include_once($path_to_root . "/inventory/includes/db/personal_material_requisitions_db.inc");
include_once($path_to_root . "/inventory/includes/db/job_material_requisitions_db.inc");
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/approval_functions.inc"); 

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if ((isset($_GET['pmr_no']) && is_numeric($_GET['pmr_no'])) || (isset($_POST['pmr_no']) && is_numeric($_POST['pmr_no']))) {
    $pmr_no = $_POST['pmr_no'] = isset($_GET['pmr_no']) ? $_GET['pmr_no'] : $_POST['pmr_no'];
    
    $page_title = _($systypes_array[ST_PERSONAL_MATERIAL_REQ]); 
    
} elseif (isset($_GET['ModifyPMR_No']) || isset($_POST['ModifyPMR_No'])) {
    $_POST['ModifyPMR_No'] = isset($_GET['ModifyPMR_No']) ? $_GET['ModifyPMR_No'] : $_POST['ModifyPMR_No'];
    $pmr_no = $_POST['ModifyPMR_No'];
    
    $header = get_job_material_requisition_header_record($pmr_no);
        if (is_array($header)) {
            if ($header['type'] != ST_PERSONAL_MATERIAL_REQ) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
            
            $trans_no = $header['trans_no'];
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Invalid transaction ID."));
            display_footer_exit();
        }
    
    $page_title = _('Modify '.$systypes_array[ST_PERSONAL_MATERIAL_REQ]." #$trans_no" );
    
} elseif (isset($_GET['type']) && (isset($_GET['ApprovedID']) || isset($_GET['RejectedID']) || isset($_GET['BackedOrgID']))) {
    $page_title = _($systypes_array[$_GET['type']]);
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Invalid transaction type."));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_GET['ApprovedID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['ApprovedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmr_messages');
    clear_session_variable('pmr_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmr_bo_messages');
    clear_session_variable('pmr_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmr_rj_messages');
    clear_session_variable('pmr_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_POST['Approve_PMR'])) {
    $msg = save_personal_material_requisition_header_only($pmr_no, true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_PMR'])) {
    $msg = back_to_originator_personal_material_requisition($pmr_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_PMR'])) {
    $msg = reject_personal_material_requisition($pmr_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Save_PMR_Header'])) {
    $msg = save_personal_material_requisition_header_only($pmr_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            $Mode = 'RESET';
        }
}

if (isset($_POST['Add_PMR']) || isset($_POST['Update_PMR'])) {        
    $msg = save_personal_material_requisition($pmr_no, $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_personal_material_requisition_details();
            $Mode = 'RESET';
        }
}

if ($Mode == 'Delete') {
    $msg = delete_personal_material_requisition_line($pmr_no, $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_personal_material_requisition_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['cancel'])) {
    clear_personal_material_requisition_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}  

if ($Mode == 'RESET') {
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($pmr_no)) {
        hidden('pmr_no', $pmr_no);
    } elseif (isset($_POST['pmr_no'])) {
        hidden('pmr_no', $_POST['pmr_no']);
        $pmr_no = $_POST['pmr_no'];
    } elseif(isset($_POST['ModifyPMR_No'])) {
        hidden('ModifyPMR_No', $_POST['ModifyPMR_No']);
        $pmr_no = $_POST['ModifyPMR_No'];
    } 

    $Ajax->activate('nsit_header');
    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        display_personal_material_requisition_header($pmr_no);

        $header = get_job_material_requisition_header($pmr_no);
            if (is_array($header)) {
                submit_center_first('Save_PMR_Header', _("Save Header"), '', 'default');    

                submit('Approve_PMR', _("Release for Approval"), true,  _("Release for Approval"), false, ICON_SUBMIT);
                
                submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);                br(2);
                
                start_table();
                    submit_center_first('REJECT_PMR', _("Reject ".$systypes_array[ST_PERSONAL_MATERIAL_REQ]), '', true, ICON_DELETE);    

                    submit('BACK_TO_ORIGINATOR_PMR', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                end_table(2);
            }

        display_personal_material_requisition_details($pmr_no, $selected_id, $Mode);

    div_end();
    
end_form();
end_page(@$_GET['popup'], false, false);        

?>